@echo off
:: build a correctly formatted 'ivdata.asc' from my raw data date time price vol
set raw=%1
if defined raw goto :start
set /p raw=enter symbol to chart, like zmz22: 
if not defined raw exit /b
echo 'raw' now set to %raw%. Must match incoming filename from laptop

:start
setlocal
set ppr=0
echo raw source data coming from %raw%
set ini=%raw%.ini
:: MINIMUM of four posted lines required to display a virgin chart.
:: if 'FM_.DAT' doesn't exist, that means the chart is or will be virgin.
:: Posting a line to virgin chart isn't fatal, but you can't load the
:: chart until you have 4 bars.
:: ivl: number of source-elements, or samples, per chart-element, or bar
set ivl=4
set /a ivl5=ivl+1
set sk=
:: build and post base from raw using raw.ini
del ivdata.asc
call chsb
if not exist ivdata.asc goto :init
echo ready to post "base" from ivdata.asc:
type ivdata.asc
pause
call post
del ivdata.asc

:init ------------- initialize from .ini
::  set up the year and month and skip to where it left off last session.
set pv=1
set yr=77
set month=2
set sk=
if not exist %sym%.ini (
echo no ini file set up, using defaulte: vol=0 year=77 month=2, no skip
goto :ini_done
)
for /f "eol=- tokens=1-4" %%a in (%sym%.ini) do (
set /a pv=%%a+1
set yr=%%b
set month=%%c
set /a sk=%%d+0
)
:ini_done
:: any missing elements get %x, not "undefined", so add zero to normalize
set /a skip+=0
set /a yr+=0
set /a month+=0
set /a prevvol+=0
if %skip% gtr 0 set sk=skip=%skip%

::==================== PRIMARY LOOP START - wait for ????? to reach 5 lines
:mainloop
:: have to keep from posting an empty ivdata. check zmk22 count first
echo waiting on next installment of %ivl5% lines from %raw%. : C_md, X_it, F_ind, Q_uiet
set ab=0
set aa=0

:2
:: findstr does not have a C equivalent of 'FIND'. /N give line NUMBERS, not
:: count, so the following needed to get count while excluding '-'
:: if the msgbox appears, suspend 10 seconds to give cid a chance to
:: handle the call before doing any sendkeys to chart
call pid "message from admin" >nul 2>&1
set o=%errorlevel%
if o gtr 1 wsleep 8
for /f "tokens=1 delims=[]" %%a in  ('findstr "^[0-1]" %raw% 2^>nul^|find /c /v ""') do set lc=%%a
rem echo skip: %skip% lc: %lc%
rem pause
if %skip% gtr %lc% set sk=
set /a lc-=skip
if %lc% geq 5 goto :ivdata

:: a lot of codeing just for some trivial info...
if %lc% gtr %ab% (
REM TEMP DEBUG TO SHOW PROGRESS
echo] %lc%
more +%skip% %raw%
)
rem if %aa% gtr %ab% set  /p= %aa%<nul
set ab=%lc%

:: the action "menu" 3-second window to either x,c, f, or q but no prompt
set i=
skey 3
set e=%errorlevel%
rem echo %e%
if %e% equ 0 goto :2
if %e% equ 88 exit /b
:: moved the menu to bottom for easier access to importnt stuff here

:: 67 is C, 70 is F, 81 is Q
call :%e% 2>nul
goto :2


::------------------------------------------------ 5-COUNT!!!

:ivdata
set c=0
set lo=9999
set hi=0
echo begin run %sk% yr %yr%

rem pause

::---------- secondary loop start - abstract the 5 lines into one "bar" line


for /f "%sk% eol=- tokens=1-4" %%a in (%raw%) do call :xx %%a %%b %%c %%d


::======================================== POST DONE HERE
call post
del ivdata.asc

:: put stochastic alert here if desired
goto :mainloop

:xx  - called for each raw-data element. just check for hi, lo, etc.
set k=%1
echo %*
:: this only happens when i import manually - ie "comment" lines start with -
if "%k:~0,2%" equ "--" goto :eof
set pr=%3
set pr=%pr:.=%
if not defined open set open=%3
rem  just check/capture hi,lo. two each, one for compare, one for output
if %pr% gtr %hi% (
 set hi=%pr%
 set hi_x=%3
)
if %pr% lss %lo% (
set lo=%pr%
set lo_x=%3
)
:: this might need to be below the increment. i always get 'fused on this issu
if %c% equ %ivl% goto :newday
set /a c+=1
goto :eof

:newday
:: raw vol is cumulative, ivdata is vol-per-bar. Safety the vol so not neg.
set vol=%4
if %vol% gtr %prevvol% set /a vol-=prevvol
::new method: hour becomes month 1-12, ivgraf allows day as minutes 0-59
:: so dates in ivgraph look like f/e 800802 for 8:02 pm opening. This will
:: proceed thru 8:59 like 800859. At 1, am or pm, the year will increment.
call fd %2

:: ****** year incrementation / rollover whenever curr. month less than prev
if %errorlevel% lss %month% set /a yr+=1
set month=%errorlevel%
:: find the line number of the last line processed to generate skip-value
for /f "tokens=1 delims=:" %%h in ('findstr /n /c:" %2 %3 %4" %raw%') do set skip=%%h
echo findstr /n /c:" %2 %3 %4" %raw%  skip: %skip% errorlevel: %errorlevel%
:: CANNOT USE ERRORLEVEL from a for-embedded command!!!
rem pause
if defined skip (set sk=skip=%skip%) else (set sk=)

:OUTPUTS -------- 2 is the time. 1 is now the date from file instead of %date%
set lineout=%raw%,%yr%%fd%,%open%,%hi_x%,%lo_x%,%3,%vol%,0    %2
set dt=%1
>>ivdata.asc echo %lineout%
:oo
:: keep a 2nd file in case chart needs rebuilt due to ???
>>ivtemp echo %lineout% %dt:~0,5%
echo OUT TO CHART ======== %lineout%
:: option for hi-lo sound effect. 1 is the "bong", 2 is the "bling"
if %ppr% gtr %pr% (set sound=2) else (set sound=1)

set ppr=%pr%
set c=0
set open=
set hi=0
set lo=9999
set prevvol=%4
REM set /a skip+=ivl5 NO, this is done using the 'FIND' above

::+++++++++++++++ ini output here. skip is a INTEGER
echo skip out to %raw%.ini: %skip%
> %ini% echo %prevvol% %yr% %month% %skip%
exit /b

:: might revert to this. i think it's probly a better method. just keep
:: raw at 5 or less lines, delete every 5-line chunk
:: OBSOLETE remove the top 5 lines to get the next chunk
:: now handled using 'skip=' instead. at ':newday' top
more +%ivl5% %raw% > tmp
copy tmp %raw% > nul
goto :eof



:: -------  MENU ELEMENTS 67 is C, 70 is F, 81 is Q
:81
if not defined quiet (set quiet=1) else (set quiet=)
exit /b
set /a quiet=-quiet
exit /b
:67
set /p i=command:
%i%
exit /b
:70
set /p i=search string ivtemp:
if not defined i exit /b
:: this 'sort-of' works as long as user observes quote pairs
echo %i% | find """"||set i="%i%"
:: here's possibly a more robust version
:: set q=
:: echo i | findstr "\<"".*\>""||set q="
:: set i=%q%%i%%q%
:: if user fucks up with unpaird quote, q will remain undefined, but user
:: will get well-deserved garbage in his search.
find /n /i %i% ivtemp
exit /b


